# -*- coding: utf-8 -*-
"""
Created on Wed Nov  1 12:25:53 2017

@author: as
"""
import sys
import os
from PyQt5 import  QtCore, QtGui ,QtWidgets 
from PyQt5.QtWidgets import  QFileDialog
import newWindow
import load
import process
import pandas as pd
import numpy as np
import shutil
import re
import time
import stat_liu
from elm import  GenELMClassifier
from random_layer import RBFRandomLayer
from sklearn import neighbors  
from sklearn.svm import SVC 
from sklearn.naive_bayes import MultinomialNB 
from sklearn.tree import DecisionTreeClassifier
class TestWnd(QtWidgets.QMainWindow,newWindow.Ui_MainWindow): 
    '''
    主窗口的类
    '''
    def __init__(self, parent=None): 
        super(TestWnd, self).__init__(parent) 
        self.setupUi(self)
        
        self.address="./data"  #打开数据文件默认路径
        self.save_address="/home/liuqw"
        self.Is_open_data = 0  #标记是否打开数据集文件路径
        self.Is_open_label = 0  #标记是否打开标签集文件路径
        self.Is_open_set = 0    #标记数据集、标签集是否都打开了
        self.Is_replace = 0
        self.Is_change = 0
        self.Is_reduce = 0
        self.textBrowser_data_output = ''
        self.textBrowser_feature_ouput = ''
        
        self.load_data.clicked.connect(self.Open_Data_set)
        self.load_label.clicked.connect(self.Open_Label_set)
        self.run.clicked.connect(self.run_function)
        self.change_affirm.clicked.connect(self.Change_table)
        self.save_table.clicked.connect(self.Save_Table)
        self.save_top_picture.clicked.connect(self.Save_Top_ACC_AVC)
        self.save_all_picture.clicked.connect(self.Save_ALL)
        self.summarize.clicked.connect(self.summarize_event)
        self.clear.clicked.connect(self.clear_event)
        self.exit.clicked.connect(self.exit_event)
        self.top_panorama.clicked.connect(self.top_pan_event)
        self.all_panorama.clicked.connect(self.all_pan_event)
        self.reduce.clicked.connect(self.reduce_redundancy)
        
        self.summarize.setDisabled(True)
        self.clear.setDisabled(True)
        self.run.setDisabled(True)
        self.change_affirm.setDisabled(True)
        self.table.setEditTriggers(QtWidgets.QTableWidget.NoEditTriggers) 
        self.table.horizontalHeader().setStretchLastSection(True)
        self.table.horizontalHeader().setSectionResizeMode(QtWidgets.QHeaderView.Stretch)
        
        self.textBrowser_data.setFont(QtGui.QFont('SansSerif',12)) 
        self.textBrowser_feature.setFont(QtGui.QFont('SansSerif',12)) 
        
        self.Is_exist_fileset()
    
    def top_pan_event(self):
        if self.Is_change == 0:
            process.draw_select_picture(self.rankmatric,int(self.top_x.currentText()),self.acc_avc.currentText(),self.value_rank.value(),1)        
        else:
            process.draw_select_picture(self.picture_matric,self.Top_num,self.select_who,self.value_rank.value(),1) 
        
    def all_pan_event(self):
        if self.Is_change == 0:
            process.draw_all_picture(self.rankmatric,int(self.top_x.currentText()),self.acc_avc.currentText(),1)
        else:
            process.draw_all_picture(self.picture_matric,self.Top_num,self.select_who,1) 
        
    
    
    def exit_event(self):
        self.close()
    
    def Is_exist_fileset(self):
        if os.path.exists('./data') == False :
            os.makedirs('./data')
        if os.path.exists('./temp') == False :
            os.makedirs('./temp')
        
    def clear_event(self):
        process.draw_blank()
        self.textBrowser_feature_ouput = ''
        _translate = QtCore.QCoreApplication.translate
        self.textBrowser_feature.setText(_translate("MainWindow", self.textBrowser_feature_ouput)) 
        
        pixmap=QtGui.QPixmap()
        pixmap.load("temp/blank.png")
        self.scene=QtWidgets.QGraphicsScene(self)
        item=QtWidgets.QGraphicsPixmapItem(pixmap)
        self.scene.addItem(item)
        self.bar_feature.setScene(self.scene)
        self.bar_feature.show()  
        
        self.feature_name.clear()
        
        
    def fuzzyfinder(self,user_input, collection):
        suggestions = []
        pattern = '.*?'.join(user_input)    # Converts 'djm' to 'd.*?j.*?m'
        regex = re.compile(pattern)         # Compiles a regex.
        for item in collection:
            match = regex.search(item)      # Checks if the current item matches the regex.
            if match:
                suggestions.append((len(match.group()), match.start(), item))
        return [x for _, _, x in sorted(suggestions)]
    def summarize_event(self):
        
        temp_str = self.feature_name.text()
        
        
        if temp_str == '' :
            line_end = min(20,len(self.index_name))
            output = '\nsome feature in feature_set:\n'
            for i in range(line_end):
                output = output + str(i) + "  " + self.index_name[i] + '\n'
            _translate = QtCore.QCoreApplication.translate
            self.textBrowser_feature_ouput = self.textBrowser_feature_ouput + output
            self.textBrowser_feature.setText(_translate("MainWindow", self.textBrowser_feature_ouput))              
            self.textBrowser_feature.moveCursor(QtGui.QTextCursor.End)            
        elif temp_str in self.index_name :
            match_set = self.fuzzyfinder(temp_str,self.index_name)
            match_set.reverse()
            output = '\nFuzzy matching with \'' + temp_str + '\' :\n'
            for i in match_set:
                output = output + i + '\n'
            _translate = QtCore.QCoreApplication.translate
            self.textBrowser_feature_ouput = self.textBrowser_feature_ouput + output
            self.textBrowser_feature.setText(_translate("MainWindow", self.textBrowser_feature_ouput))
            self.textBrowser_feature.moveCursor(QtGui.QTextCursor.End)  #滚动条到最后一行  
            
                                               
            output = '\nstatistics of ' + temp_str + ':\n'            
            self.temp_data = list(self.dataset.iloc[self.index_name.index(temp_str),:])
            data_min = min(self.temp_data)     
            data_max = max(self.temp_data)
            data_mean = np.mean(self.temp_data)
            data_var = np.var(self.temp_data)
            data_std = np.std(self.temp_data)
            data_median = np.median(self.temp_data)
            output = output + "min : " + str(data_min) + "\nmax : " + str(data_max) +"\nmean : " \
                         + str(data_mean)+"\nvar : "+ str(data_var)+"\nstd : "+ str(data_std)+"\nmedian : "+ str(data_median) + '\n'
            _translate = QtCore.QCoreApplication.translate
            self.textBrowser_feature_ouput = self.textBrowser_feature_ouput + output
            self.textBrowser_feature.setText(_translate("MainWindow", self.textBrowser_feature_ouput))  
            self.textBrowser_feature.moveCursor(QtGui.QTextCursor.End)    
            scope = np.linspace(data_min,data_max,11)
            count = [0]*10 #10个区间的统计个数
            count[0] = 1
            for s in self.temp_data:
                for j in range(10):
                    if s > scope[j] and s <= scope[j+1]:
                        count[j] += 1
            process.draw_feature_bar(data_min, data_max, count, temp_str)
            self.fillfull_feature_bar()
            
            
            
        else:
            match_set = self.fuzzyfinder(temp_str,self.index_name)
            match_set.reverse()
            if len(match_set) == 0 :
                QtWidgets.QMessageBox.critical(self,"Critical", self.tr("No matched feature!"))  
            elif len(match_set) == 1:
                only_feature = match_set[0]
                output = '\nFuzzy matching with \'' + temp_str + '\' :\n'
                for i in match_set:
                    output = output + i + '\n'
                _translate = QtCore.QCoreApplication.translate
                self.textBrowser_feature_ouput = self.textBrowser_feature_ouput + output
                self.textBrowser_feature.setText(_translate("MainWindow", self.textBrowser_feature_ouput))
                
                output = '\nstatistics of ' + only_feature + ':\n'
            
                self.temp_data = list(self.dataset.iloc[self.index_name.index(only_feature),:])
                data_min = min(self.temp_data)     
                data_max = max(self.temp_data)
                data_mean = np.mean(self.temp_data)
                data_var = np.var(self.temp_data)
                data_std = np.std(self.temp_data)
                data_median = np.median(self.temp_data)
                output = output + "min : " + str(data_min) + "\nmax : " + str(data_max) +"\nmean : " \
                             + str(data_mean)+"\nvar : "+ str(data_var)+"\nstd : "+ str(data_std)+"\nmedian : "+ str(data_median) + '\n'
                _translate = QtCore.QCoreApplication.translate
                self.textBrowser_feature_ouput = self.textBrowser_feature_ouput + output
                self.textBrowser_feature.setText(_translate("MainWindow", self.textBrowser_feature_ouput))  
                self.textBrowser_feature.moveCursor(QtGui.QTextCursor.End)    
                scope = np.linspace(data_min,data_max,11)
                count = [0]*10 #10个区间的统计个数
                count[0] = 1
                for s in self.temp_data:
                    for j in range(10):
                        if s > scope[j] and s <= scope[j+1]:
                            count[j] += 1
                process.draw_feature_bar(data_min, data_max, count, only_feature)
                self.fillfull_feature_bar()
                
            else:
                output = '\nFuzzy matching with \'' + temp_str + '\' :\n'
                for i in match_set:
                    output = output + i + '\n'
                _translate = QtCore.QCoreApplication.translate
                self.textBrowser_feature_ouput = self.textBrowser_feature_ouput + output
                self.textBrowser_feature.setText(_translate("MainWindow", self.textBrowser_feature_ouput))
                self.textBrowser_feature.moveCursor(QtGui.QTextCursor.End)  #滚动条到最后一行  
            
    
    def get_FileSize(self, filePath, unit):
        fsize = os.path.getsize(filePath)
        if unit == 'MB' :
            fsize = fsize/float(1024*1024)
        elif unit == 'KB' :
            fsize = fsize/float(1024)
        return round(fsize,2)
    
    
    def Open_Data_set(self):
        '''
        打开数据集文件路径
        '''
        
        fileName , selectedFilter = QFileDialog.getOpenFileName(
                self,("theme"),(self.address),("(*.csv);;(*.tsv)"))
        self.Data_name = fileName
        location = fileName.rfind('/')
        new_address = fileName[:location+1]
        self.address=new_address
        
        
        if fileName != "" :
            self.index_name, self.dataset, self.dataset_sample = load.processing_data(self.Data_name)
            self.dataset_sample = [x.upper() for x in self.dataset_sample]
            output = '\nData matrix file: <'+fileName[ location+1 : ]+'>\n- Number of samples: '\
                     +str(np.array(self.dataset).shape[1])+'\n- Number of features: '+str(self.dataset.shape[0])\
                         +'\n- Size of file: '+str(self.get_FileSize(self.Data_name,'MB'))+'MB\n'
        
            self.textBrowser_data_output = self.textBrowser_data_output + output
            _translate = QtCore.QCoreApplication.translate
            self.textBrowser_data.setText(_translate("MainWindow", self.textBrowser_data_output))
            self.Is_open_data = 1
        
        if self.Is_open_data == 1 and self.Is_open_label == 1 :
#            self.count_class = []
#            for i in self.class_set:
#                self.count_class.append(0)
#            for i in self.label_set :
#                self.count_class[self.class_set.index(i)] += 1
                   
            output = '\nSample numbers for the classes:\n'
            for i in range(len(self.class_set)) :
                output = output + self.class_set[i] + ' : ' + str(self.count_class[i])+ '\n'
            self.textBrowser_data_output = self.textBrowser_data_output + output
            _translate = QtCore.QCoreApplication.translate
            self.textBrowser_data.setText(_translate("MainWindow", self.textBrowser_data_output))
            
            self.textBrowser_data_output = ''
            self.Is_open_data = 0
            self.Is_open_label = 0
            self.Is_open_set = 1
            self.Is_replace = 0
            self.sample_difference = list(set(self.dataset_sample).difference(set(self.labelset_sample)))
            if len(self.label_set) == np.array(self.dataset).shape[1] :
                if len(self.sample_difference) == 0:
                    self.summarize.setEnabled(True)
                    self.clear.setEnabled(True)
                    self.run.setEnabled(True)
                else:
                    difference = ''
                    for element in self.sample_difference:
                        difference = difference + element + ' '
                    QtWidgets.QMessageBox.critical(self,"Critical", self.tr(difference + "aren't in  class labels!"))  
                
                        
            else:
                QtWidgets.QMessageBox.critical(self,"Critical", self.tr("The sample of data mateix doesn't matched the sample of class labels!"))  
                
           
            
          
    def Open_Label_set(self):
        '''
        打开标签集文件路径
        '''
        fileName  , selectedFilter = QFileDialog.getOpenFileName(
                self,("theme"),(self.address),("(*.csv);;(*.tsv)"))
        self.Label_name = fileName    
        location = fileName.rfind('/')       
        new_address = fileName[:location+1]
        self.address=new_address
        
        if fileName != "" :
            flag, self.label_set, self.class_set, self.labelset_sample = load.processing_class(self.Label_name)
            self.labelset_sample = [ x.upper() for x in self.labelset_sample]
            if flag == 1 :
                output = '\nClass label file: <'+fileName[ location+1 : ]+'>\n- Number of samples: '+str(len(self.label_set))+'\n- Number of classes: '+str(len(self.class_set))+'\n- Size of file: '+str(self.get_FileSize(self.Label_name,'KB'))+'KB\n'                                      
                self.textBrowser_data_output = self.textBrowser_data_output + output
                _translate = QtCore.QCoreApplication.translate
                self.textBrowser_data.setText(_translate("MainWindow", self.textBrowser_data_output))
                self.Is_open_label = 1
                
                
                self.count_class = []
                for i in self.class_set:
                    self.count_class.append(0)
                for i in self.label_set :
                    self.count_class[self.class_set.index(i)] += 1
                
                self.class_set_count = []
                for i in range(len(self.class_set)) :
                    self.class_set_count.append(self.class_set[i]+'('+str(self.count_class[i])+')')
                
                
                for i in range(len(self.class_set_count)) :
                    if self.class_set_count[i][0] == 'P' :
                        P_position = i
                    elif self.class_set_count[i][0] == 'N' :
                        N_position = i
                
                self.positive.clear()
                self.positive.addItems(self.class_set_count)
                self.positive.setCurrentIndex(P_position)
                self.negative.clear()
                self.negative.addItems(self.class_set_count)
                self.negative.setCurrentIndex(N_position)
            else:
                QtWidgets.QMessageBox.critical(self,"Critical", self.tr("Pleas make sure 'Class' in label set!"))  
                return 
                
        
        if self.Is_open_data == 1 and self.Is_open_label == 1 :
            
                   
            output = '\nSample numbers for the classes:\n'
            for i in range(len(self.class_set)) :
                output = output + self.class_set[i] + ' : ' + str(self.count_class[i])+ '\n'
            self.textBrowser_data_output = self.textBrowser_data_output + output
            _translate = QtCore.QCoreApplication.translate
            self.textBrowser_data.setText(_translate("MainWindow", self.textBrowser_data_output))
            
            self.textBrowser_data_output = ''
            self.Is_open_data = 0
            self.Is_open_label = 0
            self.Is_open_set = 1
            self.Is_replace = 0
            self.sample_difference = list(set(self.dataset_sample).difference(set(self.labelset_sample)))
            if len(self.label_set) == np.array(self.dataset).shape[1] :
                if len(self.sample_difference) == 0:
                    self.summarize.setEnabled(True)
                    self.clear.setEnabled(True)
                    self.run.setEnabled(True)
                else:
                    difference = ''
                    for element in self.sample_difference:
                        difference = difference + element + ' '
                    QtWidgets.QMessageBox.critical(self,"Critical", self.tr(difference + "aren't in  class labels!"))  
            else:
                QtWidgets.QMessageBox.critical(self,"Critical", self.tr("The sample of data matrix doesn't matched the sample of class labels!"))  
                
      
            
    
    def replace_class(self):
        self.Is_replace = 1
        temp_str = self.positive.currentText()
        location = temp_str.rfind('(')
        temp_str = temp_str[:location]
        for i in range(len(self.label_set)):
            if self.label_set[i] == temp_str:
                self.label_set[i] = 1
            else:
                self.label_set[i] = 0



    def run_function(self):
        start = time.time()
        self.change_affirm.setDisabled(True)
        self.run.setDisabled(True)
        QtWidgets.QMessageBox.information(self,"Waiting", self.tr("Please click \"OK\" to continue, this process may cost a few seconds or minutes. Please be patient.")) 
        if self.positive.currentText() == self.negative.currentText() :
            QtWidgets.QMessageBox.critical(self,"Critical", self.tr("Pleas make sure the difference of positive and negative before clicking Run!"))  
            self.run.setEnabled(True)
            return
        
        if self.Is_replace == 0:
            self.replace_class()
        
        #### 算法核心部分 ####
        self.pvalue_sort = process.p_value_sort(np.array(self.dataset),self.label_set)
        result, count , value_max= process.TripleTest(np.array(self.dataset),self.label_set,self.pvalue_sort,int(self.top_x.currentText()),self.acc_avc.currentText(),float(self.value.value()),self.classifier.currentText())
        if count == 0 :
            self.fillfull_table_blank()
            process.draw_picture_blank(int(self.top_x.currentText()),self.acc_avc.currentText())
            self.fillfull_top_picture()
            self.fillfull_all_picture()
            self.run.setEnabled(True)
            QtWidgets.QMessageBox.critical(self,"Critical", self.tr("There is no qualified Triplets!\nThe max value="+str(value_max)+" \nPlease lower the value to try again."))              
            return
        rankmatrix,download_pd_value, download_pd = process.create_excel(result,self.pvalue_sort,int(self.top_x.currentText()),self.acc_avc.currentText(),self.index_name)      
        num = len(download_pd.loc[:,self.acc_avc.currentText()])
        self.value_rank.setMaximum(num)
        self.value_rank.setValue(num)
        process.draw_select_picture(rankmatrix,int(self.top_x.currentText()),self.acc_avc.currentText(),num,0)        
        process.draw_all_picture(rankmatrix,int(self.top_x.currentText()),self.acc_avc.currentText(),0)
        self.rankmatric=rankmatrix
        self.matric=download_pd_value
        self.download_pd=download_pd
        self.picture_matric = self.rankmatric
        
        self.Top_num=int(self.top_x.currentText())
        self.select_who=self.acc_avc.currentText()
        self.select_value=float(self.value.value())   
        self.change_affirm.setEnabled(True)
        self.change_value.setMinimum(self.select_value)
        self.change_value.setProperty("value", self.select_value)
        if self.select_who == 'Acc' :
            self.change_value.setMaximum(self.matric[0][3])
        else: 
            self.change_value.setMaximum(self.matric[0][4])
        self.fillfull_table()
        self.fillfull_top_picture()
        self.fillfull_all_picture()
        self.run.setEnabled(True)
        self.save_all_picture.setEnabled(True)
        self.save_table.setEnabled(True)
        self.save_top_picture.setEnabled(True)
        self.top_panorama.setEnabled(True)
        self.all_panorama.setEnabled(True)
        self.reduce.setEnabled(True)
        end = time.time()
        QtWidgets.QMessageBox.information(self,"Information", self.tr("The analysis process used  "+str(end - start)+"s."))
    
    def reduce_redundancy(self):
        self.Is_reduce = 1
        import pymrmr
        Is_countered = {}
        classifer = self.classifier.currentText()
        if classifer == 'ELM' :      
            rbf_rhl = RBFRandomLayer(n_hidden=20, rbf_width=0.01,random_state=0)
            clf = GenELMClassifier(hidden_layer=rbf_rhl)    
        elif classifer == 'SVM':
            clf = SVC(kernel='linear', C=1)
        elif classifer == 'KNN':
            clf=neighbors.KNeighborsClassifier(n_neighbors = 3 )
        elif classifer == 'Normal_Bayes':
            clf=MultinomialNB(alpha=0.01)
        else:
            clf = DecisionTreeClassifier(random_state=0)
        for i in range(len(self.download_pd)):
            fea1 = str(self.download_pd.loc[i,'f1'])
            fea2 = str(self.download_pd.loc[i,'f2'])
            fea3 = str(self.download_pd.loc[i,'f3'])
            value = self.download_pd.loc[i,self.select_who]
            index_array = [self.index_name.index(fea1),self.index_name.index(fea2),self.index_name.index(fea3)]
            pd_array = ['f1','f2','f3']
            temp = self.dataset.iloc[index_array]
            temp = temp.T
            temp.insert(0,'class',self.label_set) 
            new_index = [x for x in range(len(temp))]
            temp.index = new_index
            temp.to_csv('./temp/test2.csv',index = False)
            df = pd.read_csv('./temp/test2.csv')
            
            mrmr_fea = pymrmr.mRMR(df,'MIQ',1)
            #print(mrmr_fea)
            if mrmr_fea[0] not in list(Is_countered.keys()) :
                data = df.loc[:,mrmr_fea]             
                Sn,Sp,Acc,Avc=stat_liu.statistics(self.label_set,stat_liu.kFoldTest(clf,data.values,self.label_set))
                if self.select_who == 'Acc':
                    if Acc >= value:
                        eternal = index_array.index(int(mrmr_fea[0]))                       
                        for j in range(3):
                            if j != eternal:
                                self.download_pd.loc[i,pd_array[j]] = None
                        self.download_pd.loc[i,self.select_who] = Acc
                        Is_countered[mrmr_fea[0]] = Acc
                else:
                    if Avc >= value:
                        eternal = index_array.index(int(mrmr_fea[0]))
                        for j in range(3):
                            if j != eternal:
                                self.download_pd.loc[i,pd_array[j]] = None                                                                                       
                        self.download_pd.loc[i,self.select_who] =Avc                                              
                        Is_countered[mrmr_fea[0]] = Avc  
            else:
                if self.select_who == 'Acc':
                    if Is_countered[mrmr_fea[0]] >= value:
                        self.download_pd = self.download_pd.drop(i)                                             
                else:
                    if Is_countered[mrmr_fea[0]] >= value:                                           
                        self.download_pd = self.download_pd.drop(i)                                    
        self.matric = self.download_pd.values
        self.rankmatric=np.zeros((np.shape(self.matric)[0],5))  
        temp_arr = []
        for i in range(self.Top_num):
            temp_arr.append(self.index_name[self.pvalue_sort[i][0]])      
        for i in range(len(self.matric)):
            self.rankmatric[i][3] = self.matric[i][3]
            self.rankmatric[i][4] = self.matric[i][4]
            for j in range(3):
                if self.matric[i][0] in temp_arr:
                    self.rankmatric[i][0] = temp_arr.index(self.matric[i][0])
                else:
                    self.rankmatric[i][0] = -1
                if self.matric[i][1] in temp_arr:
                    self.rankmatric[i][1] = temp_arr.index(self.matric[i][1])
                else:
                    self.rankmatric[i][1] = -1
                if self.matric[i][2] in temp_arr:
                    self.rankmatric[i][2] = temp_arr.index(self.matric[i][2])
                else:
                    self.rankmatric[i][2] = -1
        self.fillfull_table()
        self.Change_table()
#        process.draw_select_picture(self.rankmatric,int(self.top_x.currentText()),self.acc_avc.currentText(),self.value_rank.value(),0)        
#        process.draw_all_picture(self.rankmatric,int(self.top_x.currentText()),self.acc_avc.currentText(),0)
#        self.fillfull_table()
#        self.fillfull_top_picture()
#        self.fillfull_all_picture()
        self.reduce.setDisabled(True)  
            
    
    
    def fillfull_top_picture(self):
        '''
        将两张3D图输出到子窗口展示
        '''
        pixmap=QtGui.QPixmap()
        pixmap.load("temp/select_10.png")
        self.scene=QtWidgets.QGraphicsScene(self)
        item=QtWidgets.QGraphicsPixmapItem(pixmap)
        self.scene.addItem(item)
        self.top_picture.setScene(self.scene)
        self.top_picture.show()
   
    def fillfull_all_picture(self):    
        pixmap=QtGui.QPixmap()
        pixmap.load("temp/all_acc.png")
        self.scene=QtWidgets.QGraphicsScene(self)
        item=QtWidgets.QGraphicsPixmapItem(pixmap)
        self.scene.addItem(item)
        self.all_picture.setScene(self.scene)
        self.all_picture.show()    
    
    def fillfull_feature_bar(self):    
        pixmap=QtGui.QPixmap()
        pixmap.load("temp/feature_bar.png")
        self.scene=QtWidgets.QGraphicsScene(self)
        item=QtWidgets.QGraphicsPixmapItem(pixmap)
        self.scene.addItem(item)
        self.bar_feature.setScene(self.scene)
        self.bar_feature.show()  
    
    def fillfull_table_blank(self):
        self.student_model = QtGui.QStandardItemModel()
        self.table.setModel(self.student_model)
        self.table.show()
    
    def fillfull_table(self):
        '''
        把包含（F1,F2,F3,ACC/AVC）四元组的表格填充到窗口左边的区域
        '''
        self.student_model = QtGui.QStandardItemModel()
        
        if self.select_who == 'Acc' :
           
            self.student_model.setHorizontalHeaderLabels(['F1','F2','F3','Acc'])
            for i in range(self.matric.shape[0]):
                for j in range(4):
                    self.student_model.setItem(i, j, QtGui.QStandardItem(str(self.matric[i][j])))
                    self.student_model.item(i, j).setTextAlignment(QtCore.Qt.AlignCenter)
        else:
            self.student_model.setHorizontalHeaderLabels(['F1','F2','F3','bAcc'])
            for i in range(self.matric.shape[0]):
                for j in [0,1,2,4]:
                    if j==4 :
                        self.student_model.setItem(i, j-1, QtGui.QStandardItem(str(self.matric[i][j])))
                        self.student_model.item(i, j-1).setTextAlignment(QtCore.Qt.AlignCenter)
                    else:
                        self.student_model.setItem(i, j, QtGui.QStandardItem(str(self.matric[i][j])))
                        self.student_model.item(i, j).setTextAlignment(QtCore.Qt.AlignCenter)
        
        self.table.setModel(self.student_model)
        for i in range(8):
            if i <3 :
                self.table.setColumnWidth(i,90) 
            else:
                self.table.setColumnWidth(i,80)
        self.table.show()
        
        
    def Change_table(self):      
        '''
        根据最小ACC/AVC动态调整输出的table的内容
        '''
        self.Is_change = 1
        self.change_affirm.setDisabled(True)      
        if self.Is_reduce == 0:
            QtWidgets.QMessageBox.information(self,"Waiting", self.tr("Please click \"OK\" to continue, this process may cost a few seconds or minutes. Please be patient.")) 
        count = 0
        if self.select_who == 'Acc' :           
            #count=0
            for i in range(self.matric.shape[0]):                
                if self.matric[i][3]<self.change_value.value() :
                    count=i
                    break
                if i==self.matric.shape[0]-1:
                    count=i+1       
            indexs=self.student_model.rowCount()            
            if indexs>count:                
                while indexs>=count :
                    self.student_model.removeRow(indexs)
                    indexs-=1      
                self.value_rank.setValue(min(count,self.value_rank.value()))
            elif indexs<count:                
                for i in range(indexs,count):
                    for j in range(4):
                        self.student_model.setItem(i, j, QtGui.QStandardItem(str(self.matric[i][j])))
                        self.student_model.item(i, j).setTextAlignment(QtCore.Qt.AlignCenter)
                self.value_rank.setValue(min(count,self.value_rank.value()))
            else:
                pass                       
        else:
            #count=0
            for i in range(self.matric.shape[0]):
                
                if self.matric[i][4]<self.change_value.value() :
                    count=i
                    break
                if i==self.matric.shape[0]-1:
                    count=i+1           
            indexs=self.student_model.rowCount()            
            if indexs>count:               
                while indexs>=count :
                    self.student_model.removeRow(indexs)
                    indexs-=1        
                self.value_rank.setValue(min(count,self.value_rank.value()))
            elif indexs<count:                
                for i in range(indexs,count):
                    for j in [0,1,2,4]:
                        if j==4 :
                            self.student_model.setItem(i, j-1, QtGui.QStandardItem(str(self.matric[i][j])))
                            self.student_model.item(i, j-1).setTextAlignment(QtCore.Qt.AlignCenter)
                        else:
                            self.student_model.setItem(i, j, QtGui.QStandardItem(str(self.matric[i][j])))
                            self.student_model.item(i, j).setTextAlignment(QtCore.Qt.AlignCenter)
                self.value_rank.setValue(min(count,self.value_rank.value()))
        self.table.setModel(self.student_model)
        for i in range(8):
            if i <3 :
                self.table.setColumnWidth(i,80) 
            else:
                self.table.setColumnWidth(i,60)
        self.table.show()
        num = 0
        if self.select_who == 'Acc' :
            self.rankmatric = self.rankmatric[self.rankmatric[:,3].argsort()]
            self.picture_matric = self.rankmatric[ (-count) : , : ] 
            num = len(self.picture_matric[:,3])
        else:
            self.rankmatric = self.rankmatric[self.rankmatric[:,4].argsort()]
            self.picture_matric = self.rankmatric[ (-count): , : ]
            num = len(self.picture_matric[:,4])
        self.value_rank.setMaximum(num)
        #self.value_rank.setValue(num)
        process.draw_all_picture(self.picture_matric,self.Top_num,self.select_who,0) 
        self.fillfull_all_picture()
       
        process.draw_select_picture(self.picture_matric,self.Top_num,self.select_who,self.value_rank.value(),0) 
        self.fillfull_top_picture()
        
        self.change_affirm.setEnabled(True)

    def Save_Table(self):
        '''
        保存表格
        '''
        directory, ok = QFileDialog.getSaveFileName(self,  
                                    "Save_Table",  
                                    self.save_address,  
                                    "(*.xlsx);;(*.csv);;(*.tsv)") 
        location = directory.rfind('/')
        new_address = directory[:location+1]
        self.save_address=new_address
        file_type = ok[2:-1]
        path = directory + file_type
        if file_type == '.xlsx':
            writer = pd.ExcelWriter(path) 
            if self.select_who == 'Acc':
                pd.DataFrame(self.download_pd.loc[:,['f1','f2','f3','Acc']]).to_excel(writer,index=False)    
            else:
                pd.DataFrame(self.download_pd.loc[:,['f1','f2','f3','bAcc']]).to_excel(writer,index=False)    
            writer.save()
        elif file_type == '.csv':
            if self.select_who == 'Acc':
                pd.DataFrame(self.download_pd.loc[:,['f1','f2','f3','Acc']]).to_csv(path,index=False,header=True)
            else:
                pd.DataFrame(self.download_pd.loc[:,['f1','f2','f3','bAcc']]).to_csv(path,index=False,header=True)
        elif file_type == '.tsv':
            if self.select_who == 'Acc':
                pd.DataFrame(self.download_pd.loc[:,['f1','f2','f3','Acc']]).to_csv(path,sep='\t',index=False,header=True)
            else:
                pd.DataFrame(self.download_pd.loc[:,['f1','f2','f3','bAcc']]).to_csv(path,sep='\t',index=False,header=True)
        else:
            pass
        
    def Save_ALL(self):
        '''
        保存所有符合标准的特征组合的3D图
        '''
        directory, ok = QFileDialog.getSaveFileName(self,  
                                    "Save_Picture",  
                                    self.save_address,  
                                    "(*.png);;(*.jpg);;(*.svg)")  
        
        location = directory.rfind('/')
        new_address = directory[:location+1]
        self.save_address=new_address
        file_type = ok[2:-1]
        path = directory + file_type
        if file_type == '.png':
            shutil.copy("temp/all_acc_dpi.png",path)
        elif file_type == '.jpg':
            shutil.copy("temp/all_acc_dpi.jpg",path)
        else:
            shutil.copy("temp/all_acc_dpi.svg",path)
        
    def Save_Top_ACC_AVC(self):
        '''
        保存十个满足阈值标准的特征组合3D图
        '''
        directory, ok = QFileDialog.getSaveFileName(self,  
                                    "Save_Picture",  
                                    self.save_address,  
                                    "(*.png);;(*.jpg);;(*.svg)")  
        location = directory.rfind('/')
        new_address = directory[:location+1]
        self.save_address=new_address
        file_type = ok[2:-1]
        path = directory + file_type
        
        if file_type == '.png':
            shutil.copy("temp/select_10_dpi.png",path)
        elif file_type == '.jpg':
            shutil.copy("temp/select_10_dpi.jpg",path)
        else:
            shutil.copy("temp/select_10_dpi.svg",path)



        
def mywindow():          
    mywindow = TestWnd()
    mywindow.show()
    return mywindow

if __name__ == '__main__':    
    if not QtWidgets.QApplication.instance():
        app = QtWidgets.QApplication(sys.argv)
    else:
        app = QtWidgets.QApplication.instance() 
    myobj = mywindow()    
    sys.exit(app.exec_())  