# -*- coding: utf-8 -*-
"""
Created on Thu Nov  2 10:42:12 2017

@author: as
"""


import numpy as np
import pandas as pd
import math
import multiprocessing
import stat_liu
from functools import partial
from scipy.stats import ttest_ind
import itertools
from elm import  GenELMClassifier
from random_layer import RBFRandomLayer
from sklearn import neighbors  
from sklearn.svm import SVC 
from sklearn.naive_bayes import MultinomialNB 
from sklearn.tree import DecisionTreeClassifier
import matplotlib.pyplot as plt
from mpl_toolkits.axes_grid1.inset_locator import inset_axes
from mpl_toolkits.mplot3d import Axes3D



def stat_features(dataset,index_name,feature_name):
    data_t= dataset.T
    stat = data_t.describe()
    
    df_stat = pd.DataFrame()
    df_stat['name'] = index_name
    df_stat['min'] = stat.loc['min',:]
    df_stat['max'] = stat.loc['max',:]
    df_stat['mean'] = stat.loc['mean',:]
    
    return df_stat
  
def p_value_sort(dataset,labelset):
    xtoy, ytoy= dataset, labelset

    l,c = xtoy.shape  #l代表特征数,c代表样本个数
    ##############################################
    #    #               样本 c             
    ##############################################
    #特  #
    #征  #
    # l  #

    
    #计算每个特征的T-Test值，二元组（T值，P值）
    ttestsocre=[]
    
    for j in range(0,l): 
        a=xtoy[j]
        set1=[] #正样本
        set2=[] #负样本
        for i in range(0,len(a)): #每个样本分类
            if(ytoy[i]==1):
                set1.append(a[i])
            else:
                set2.append(a[i])        
        ttestsocre.append(ttest_ind(set1,set2))
    
    pvalue=[]    
    for i in range(0,len(ttestsocre)):
        pvalue.append((i,ttestsocre[i][1]))#读出P值           
    pvalue_sort=sorted(pvalue,key=lambda d:d[1],reverse=False)#根据P值排名，并记录下特征的索引
    return pvalue_sort

#穷举三元组
def classify_func(combination, clf, xtoy, ytoy, i):    
    a=np.zeros((3,int(len(xtoy[1]))))#存储特征穷举三元组的原始数据 
    a[0]=xtoy[combination[i][0]] #F1
    a[1]=xtoy[combination[i][1]] #F2
    a[2]=xtoy[combination[i][2]] #F3
    aa=a.T #将a转置为样本*特征的矩阵
    Sn,Sp,Acc,Avc=stat_liu.statistics(ytoy,stat_liu.kFoldTest(clf,aa,ytoy))
    return Sn,Sp,Acc,Avc,i

	
	
def classify_func(combination, clf, xtoy, ytoy, i):    
    a=np.zeros((3,int(len(xtoy[1]))))#存储特征穷举三元组的原始数据 
    a[0]=xtoy[combination[i][0]] #F1
    a[1]=xtoy[combination[i][1]] #F2
    a[2]=xtoy[combination[i][2]] #F3
    aa=a.T #将a转置为样本*特征的矩阵
    Sn,Sp,Acc,Avc=stat_liu.statistics(ytoy,stat_liu.kFoldTest(clf,aa,ytoy))
    return Sn,Sp,Acc,Avc,i

def TripleTest(xtoy,ytoy,pvalue_sort,Top_X,select_ACC_AVC,select_value,classifer):
    index=[] 
    #x=[] 
    count=0
    for i in range(0,Top_X): #取p_value值top x进行穷举
         index.append(pvalue_sort[i][0])
         #x.append(xtoy[pvalue_sort[i][0]])
    
    if classifer == 'ELM' :      
        rbf_rhl = RBFRandomLayer(n_hidden=20, rbf_width=0.01,random_state=0)
        clf = GenELMClassifier(hidden_layer=rbf_rhl)    
    elif classifer == 'SVM':
        clf = SVC(kernel='linear', C=1)
    elif classifer == 'KNN':
        clf=neighbors.KNeighborsClassifier(n_neighbors = 3 )
    elif classifer == 'Normal_Bayes':
        clf=MultinomialNB(alpha=0.01)
    else:
        clf = DecisionTreeClassifier(random_state=0)
    combination = list(itertools.combinations(index,3))#前50个特征穷举，公19600组
    #print(index)
    #print(combination)
                
    result=[] #存储测试集正确率和训练集正确率都大于0.9的特征组合（（特征组合），训练集正确率，测试集正确率）   
    value_set = []
    i_list = [ x for x in range(len(combination))]
    worker = partial(classify_func, combination, clf, xtoy, ytoy)    
    pool = multiprocessing.Pool()
    pool_result = pool.map(worker, i_list)
    pool.close()
    pool.join()
    if select_ACC_AVC == 'Acc' :
        for res in pool_result:
            if res[2] >= select_value:
                result.append([combination[res[4]],res[2],res[3],res[0],res[1]])
                count+=1
            value_set.append(res[2])
    else :
        for res in pool_result:
            if res[3] >= select_value:
                result.append([combination[res[4]],res[2],res[3],res[0],res[1]])
                count+=1
            value_set.append(res[3])        
    return result, count, max(value_set)

#生成三元组表格
def create_excel(result,pvalue_sort,Top_X,select_who,index_name):
    raw=result        
    rawTtestResult=pvalue_sort
    rankmatrix=np.zeros((np.shape(raw)[0],5))
    download_matrix=[]#下载组合表
    for j in range(0,np.shape(raw)[0]):
        temp_matrix=[]
        f1=raw[j][0][0] #f1,f2,f3存储的特征索引
        f2=raw[j][0][1]
        f3=raw[j][0][2]
        rankmatrix[j][3]=raw[j][1]#测试集正确率
        rankmatrix[j][4]=raw[j][2]
        temp_matrix=[f1,f2,f3,round(raw[j][1],5),round(raw[j][2],5),raw[j][3],raw[j][4]]
        
        download_matrix.append(temp_matrix)
        #rankmatrix存储的是特征组合三元组所对应的p值排名
        
        for i in range(0,Top_X):
            if(rawTtestResult[i][0]==f1):
                rankmatrix[j][0]=i                
            if(rawTtestResult[i][0]==f2):
                rankmatrix[j][1]=i               
            if(rawTtestResult[i][0]==f3):
                rankmatrix[j][2]=i
    '''
    with open("temp/index_name.pkl","rb") as f:
        index_name_dic=pickle.load(f)
        f.close()
        '''
        
    #构造特征组合及正确率的Dataframe并写入Excel
    download_pd=pd.DataFrame(download_matrix,columns=['f1','f2','f3','Acc','bAcc','SN','SP'])
    for i in range(len(download_matrix)):
        download_pd.loc[i,'f1']=index_name[download_pd.loc[i,'f1']]
        download_pd.loc[i,'f2']=index_name[download_pd.loc[i,'f2']]
        download_pd.loc[i,'f3']=index_name[download_pd.loc[i,'f3']]
    download_pd=download_pd.sort_values(select_who,ascending=False)
    name="temp/comprehend.xlsx"
    writer = pd.ExcelWriter(name) 
    pd.DataFrame(download_pd).to_excel(writer,index=False)        
    writer.save()
    return rankmatrix, download_pd.values, download_pd

def draw_picture_blank(top_num, select_who):
    fig = plt.figure(figsize=(4.7,2.5))
    title="Top 10 "+select_who
    fig.suptitle(title)            
    cm = plt.cm.get_cmap('RdBu_r')  
    ax = fig.add_subplot(111, projection='3d')
    x_n=[]
    y_n=[]
    z_n=[]
    c_n=[]
    p=ax.scatter(x_n,y_n,z_n,c=c_n,vmin=0.0,vmax=1.0,s=100,cmap=cm) #enable this line and disable the next line to draw best 10 models
    ax.set_xlabel('F1')
    ax.set_ylabel('F2')
    ax.set_zlabel('F3')
    ax.set_xlim(0,top_num)
    ax.set_ylim(0,top_num)
    ax.set_zlim(0,top_num)
    my_x_ticks = np.arange(0, top_num, int(top_num/10))
    
    ax.set_xticks(my_x_ticks)
    ax.set_yticks(my_x_ticks)
    ax.set_zticks(my_x_ticks)
    axins = inset_axes(ax,
                       width="2%",  # width = 10% of parent_bbox width
                       height="40%",  # height : 50%
                       loc=3,
                       bbox_to_anchor=(1.00, 0., 1, 1),
                       bbox_transform=ax.transAxes,
                       borderpad=0,
                       )
    plt.colorbar(p,axins)
    name="temp/select_10.png"
    plt.savefig(name)
    plt.close('all')
    
    
    fig1 = plt.figure(figsize=(4.7,2.5))
    title=select_who+" of all triplets"
    fig1.suptitle(title)            
    cm1 = plt.cm.get_cmap('RdYlBu_r')  
    axes = fig1.add_subplot(111, projection='3d')
    x=[]
    y=[]
    z=[]
    c=[]
    p=axes.scatter(x,y,z,c=c,vmin=0.0,vmax=1.0,s=100,cmap=cm1)              #enable this line and disable the previous line to draw all models with accuracy over cut-off value
    axes.set_xlabel('F1')
    axes.set_ylabel('F2')
    axes.set_zlabel('F3')
    axes.set_xlim(0,top_num)
    axes.set_ylim(0,top_num)
    axes.set_zlim(0,top_num)
    my_x_ticks = np.arange(0, top_num, int(top_num/10))
    
    axes.set_xticks(my_x_ticks)
    axes.set_yticks(my_x_ticks)
    axes.set_zticks(my_x_ticks)
    axins = inset_axes(axes,
                       width="2%",  # width = 10% of parent_bbox width
                       height="40%",  # height : 50%
                       loc=3,
                       bbox_to_anchor=(1.00, 0., 1, 1),
                       bbox_transform=axes.transAxes,
                       borderpad=0,
                       )
    
    
    plt.colorbar(p,axins)
    name="temp/all_acc.png"
    plt.savefig(name)
    plt.close('all')

def draw_select_picture(rankmatric,top_num, select_who,value_rank,Is_panorama):
    rankmatrix=rankmatric
    x=[]
    y=[]
    z=[]
    c=[]
    
    m=[]
    if select_who == 'Acc':
        for i in range(0,np.shape(rankmatrix)[0]):
            x.append(rankmatrix[i][0]+1)
            y.append(rankmatrix[i][1]+1)
            z.append(rankmatrix[i][2]+1)
            c.append(rankmatrix[i][3])
            m.append((rankmatrix[i][0]+1,rankmatrix[i][1]+1,rankmatrix[i][2]+1,rankmatrix[i][3]))   
        
    else:
        for i in range(0,np.shape(rankmatrix)[0]):
            x.append(rankmatrix[i][0]+1)
            y.append(rankmatrix[i][1]+1)
            z.append(rankmatrix[i][2]+1)
            c.append(rankmatrix[i][4])
            m.append((rankmatrix[i][0]+1,rankmatrix[i][1]+1,rankmatrix[i][2]+1,rankmatrix[i][4]))  
    m.sort(key=lambda x: x[3],reverse=True)
    
    x_n=[]
    y_n=[]
    z_n=[]
    c_n=[]
   
    num = value_rank     
    while num < len(m):
        if m[num][3] == m[value_rank-1][3]:
            num += 1
        else:
            break
    for i in range(num):
        x_n.append(m[i][0])
        y_n.append(m[i][1])
        z_n.append(m[i][2])
        c_n.append(m[i][3])
    
    
    fig = plt.figure(figsize=(4.7,2.5))
    title="Top " + str(value_rank)+ " " + select_who
    fig.suptitle(title)            
    cm = plt.cm.get_cmap('RdYlBu_r')  
    ax = fig.add_subplot(111, projection='3d')
    
    if len(set(c_n)) < 5:
        vmin = 0.0
        vmax = 1.0
    else:
        vmin = min(c_n)
        vmax = max(c_n)
    
    
    p=ax.scatter(x_n,y_n,z_n,c=c_n,vmin=vmin,vmax=vmax,s=50,cmap=cm) #enable this line and disable the next line to draw best 10 models
    ax.set_xlabel('F1')
    ax.set_ylabel('F2')
    ax.set_zlabel('F3')
    ax.set_xlim(0,top_num+top_num/10)
    ax.set_ylim(0,top_num+top_num/10)
    ax.set_zlim(0,top_num+top_num/10)
    my_x_ticks = np.arange(0, top_num+top_num/10, int(top_num/10))
    
    ax.set_xticks(my_x_ticks)
    ax.set_yticks(my_x_ticks)
    ax.set_zticks(my_x_ticks)
    axins = inset_axes(ax,
                       width="2%",  # width = 10% of parent_bbox width
                       height="40%",  # height : 50%
                       loc=3,
                       bbox_to_anchor=(1.00, 0., 1, 1),
                       bbox_transform=ax.transAxes,
                       borderpad=0,
                       )
    plt.colorbar(p,axins)
    if Is_panorama == 0 :
        name="temp/select_10.png"
        plt.savefig(name)
        name="temp/select_10_dpi.png"
        plt.savefig(name,dpi=300)
        name="temp/select_10_dpi.jpg"
        plt.savefig(name,dpi=300)
        name="temp/select_10_dpi.svg"
        plt.savefig(name,format='svg')
        plt.close('all')
    else:
        plt.show()
    
    
    
    
    #=======================================================================
def draw_all_picture(rankmatric,top_num, select_who, Is_panorama):
    rankmatrix=rankmatric
    x=[]
    y=[]
    z=[]
    c=[]
    
    m=[]
    if select_who == 'Acc':
        for i in range(0,np.shape(rankmatrix)[0]):
            x.append(rankmatrix[i][0]+1)
            y.append(rankmatrix[i][1]+1)
            z.append(rankmatrix[i][2]+1)
            c.append(rankmatrix[i][3])
            m.append((rankmatrix[i][0]+1,rankmatrix[i][1]+1,rankmatrix[i][2]+1,rankmatrix[i][3]))    
    else:
        for i in range(0,np.shape(rankmatrix)[0]):
            x.append(rankmatrix[i][0]+1)
            y.append(rankmatrix[i][1]+1)
            z.append(rankmatrix[i][2]+1)
            c.append(rankmatrix[i][4])
            m.append((rankmatrix[i][0]+1,rankmatrix[i][1]+1,rankmatrix[i][2]+1,rankmatrix[i][4]))
    fig1 = plt.figure(figsize=(4.7,2.5))
    title=select_who+" of all triplets"
    fig1.suptitle(title)            
    cm1 = plt.cm.get_cmap('RdYlBu_r')  
    axes = fig1.add_subplot(111, projection='3d')
    
    if len(set(c)) < 5:
        vmin = 0.0
        vmax = 1.0
    else:
        vmin = min(c)
        vmax = max(c)
    
    p=axes.scatter(x,y,z,c=c,vmin=vmin,vmax=vmax,s=50,cmap=cm1)              #enable this line and disable the previous line to draw all models with accuracy over cut-off value
    axes.set_xlabel('F1')
    axes.set_ylabel('F2')
    axes.set_zlabel('F3')
    axes.set_xlim(0,top_num+top_num/10)
    axes.set_ylim(0,top_num+top_num/10)
    axes.set_zlim(0,top_num+top_num/10)
    my_x_ticks = np.arange(0, top_num+top_num/10, int(top_num/10))
    
    axes.set_xticks(my_x_ticks)
    axes.set_yticks(my_x_ticks)
    axes.set_zticks(my_x_ticks)
    axins = inset_axes(axes,
                       width="2%",  # width = 10% of parent_bbox width
                       height="40%",  # height : 50%
                       loc=3,
                       bbox_to_anchor=(1.00, 0., 1, 1),
                       bbox_transform=axes.transAxes,
                       borderpad=0,
                       )
    
    
    plt.colorbar(p,axins)
    if Is_panorama == 0 :
        name="temp/all_acc.png"
        plt.savefig(name)
        name="temp/all_acc_dpi.png"
        plt.savefig(name,dpi=300)
        name="temp/all_acc_dpi.jpg"
        plt.savefig(name,dpi=300)
        name="temp/all_acc_dpi.svg"
        plt.savefig(name,format='svg')
        plt.close('all')
    else:
        plt.show()

def draw_blank():
    fig = plt.figure(figsize=(4.7,2.5))
    fig.savefig('temp/blank.png')
    plt.close('all')

def draw_feature_bar(data_min, data_max, height, feature_name):   
   
    width = (data_max-data_min)/10
    ind = np.linspace(data_min, data_max, 11)  
    labels = []
    for i in ind:
        labels.append('%.2f' % i)
    # make a square figure  
    fig = plt.figure(figsize=(4.7,2.5))  
    ax  = fig.add_subplot(111)  
    # Bar Plot  
    
    ax.bar(ind[:10]+width/2,height,width,color='green')  
    # Set the ticks on x-axis  
    ax.set_xticks(ind)  
    #ax.set_xticks(range(len(ind)))
    ax.set_xticklabels(labels)     
    # labels  
    ax.set_xlabel('Numerical Interval')  
    ax.set_ylabel('Count')  
    # title  
    ax.set_title('Statistics of '+feature_name)#, bbox={'facecolor':'0.8', 'pad':5})  
    
    for xx, yy in zip(ind[:10],height):
        ax.text(xx+width/2, yy+0.1, str(yy), ha='center')
    plt.grid(True)    
    plt.savefig("temp/feature_bar.png")  
    plt.close('all') 





        
